# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# TODO: Add the following buildreqs/possibly reqs when available
#BuildRequires:	perl(Authen::NTLM)
#BuildRequires:	perl(Authen::SASL)
#BuildRequires:	perl(Digest::HMAC_MD5)

Name:		perl-Mail-IMAPClient
Version:	3.30
Release:	1.%{__distinit}%{__distvers}
Summary:	An IMAP Client API
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Mail-IMAPClient/
Source0:	http://search.cpan.org/CPAN/authors/id/P/PL/PLOBBES/Mail-IMAPClient-%{version}.tar.gz
Patch0:		Mail-IMAPClient-3.26-Perl-5.8.0.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Compress::Zlib)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(IO::Socket)
BuildRequires:	perl(IO::Socket::SSL)
BuildRequires:	perl(Parse::RecDescent)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Compress::Zlib)
Requires:	perl(Digest::MD5)
Requires:	perl(IO::Socket::SSL)

%description
This module provides perl routines that simplify a sockets connection 
to and an IMAP conversation with an IMAP server. 

%prep
%setup -q -n Mail-IMAPClient-%{version}
sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' examples/*.pl

# Turn off exec bits in examples to avoid docfile dependencies
chmod -c -x examples/*.pl

iconv -f iso-8859-1 -t utf-8 < Changes > Changes.utf8
mv Changes.utf8 Changes

# We don't really need Perl 5.8.1
%patch0 -p1

%build
# the extended tests cannot be run without an IMAP server
PERL_MM_USE_DEFAULT=1 perl Makefile.PL INSTALLDIRS=vendor < /dev/null
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README examples/
%{perl_vendorlib}/Mail/
%{_mandir}/man3/Mail::IMAPClient.3pm*
%{_mandir}/man3/Mail::IMAPClient::BodyStructure.3pm*
%{_mandir}/man3/Mail::IMAPClient::BodyStructure::Parse.3pm*
%{_mandir}/man3/Mail::IMAPClient::MessageSet.3pm*
%{_mandir}/man3/Mail::IMAPClient::Thread.3pm*

%changelog
* Sat Nov 12 2011 Paul Howarth <paul@city-fan.org> - 3.30-1
- Update to 3.30
  - StartTLS array ref argument dereferenced twice (CPAN RT#72347)
  - During connect(): Port now defaults 143 or 993 if $self->Ssl
  - Stop reconnect deep recursion if server disconnects on login
  - reconnect() now returns 1 on success; on error undef or 0=recursive
  - Handle EBADF from syswrite in _send_bytes
  - Add RFC4978 IMAP COMPRESS Extension support (CPAN RT#67263):
    - New method: compress()
    - New attributes: Compress Readmoremethod
  - General code cleanup:
    - new() now always returns $self or undef (never $sock any more)
    - Socket() now always return a socket or undef
    - login() now always return $self or undef
    - _read_more() will now use Readmoremethod if set
  - Missing second arg '' for encode_base64 causing AUTHENTICATE PLAIN to fail
    on lines longer than 76 characters
- BR/R: perl(Digest::MD5) for DIGEST-MD5 authentication support
- BR/R: perl(Compress::Zlib) for COMPRESS DEFLATE support

* Fri Aug 12 2011 Paul Howarth <paul@city-fan.org> - 3.29-1
- Update to 3.29
  - CPAN RT#69876: ENVELOPE as part of fetch_hash convenience method
  - Added Mail::IMAPClient::BodyStructure::Envelope->parse_string($str)
    convenience method for handling ENVELOPE data from fetch_hash
  - CPAN RT#68310: folders() should not call exists()/STATUS
  - Use selectable() instead of exists() in call
  - Ensure separator is set properly in folders()
  - selectable now properly checks for \Noselect flag
  - Update folders() POD to match implementation behaviour
  - CPAN RT#68648: CAPABILITY after authenticate
  - Delete cache after State set to Authenticate
  - State() is no longer an auto-generated method
  - CPAN RT#68755: Provided socket loses blocking in 3.19-3.28
- Install to vendor directories rather than perl directories

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 3.28-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sat Mar  5 2011 Paul Howarth <paul@city-fan.org> - 3.28-1
- Update to 3.28
  - CPAN RT#66004: internaldate() return undef if no internaldate in reply
  - CPAN RT#66367: multiple fixes for fetch_hash
  - Do not touch CRLF in Escape()/Unescape()
  - Added Escape() method
  - CPAN RT#66287: flags results truncated due to Maxcommandlength
  - CPAN RT#65694: SASL PLAIN: bad order of login data

* Tue Feb 15 2011 Paul Howarth <paul@city-fan.org> - 3.27-1
- Update to 3.27
  - CPAN RT#65694: Migrate fails
  - CPAN RT#65470: Uninitialized warning in message_to_file
  - CPAN RT#61835: (DOC) in LIST context undef may be returned, and warn/
    highlight behaviour in docs Errors section
  - Updated documentation
    - migrate() documentation fixed
    - Moved Custom Authentication Mechanisms toward end
    - Recommended use of scalar context due to historical API behaviour

* Tue Feb  1 2011 Paul Howarth <paul@city-fan.org> - 3.26-1
- Update to 3.26
  - See Changes for full details
  - Require Perl 5.8.1 as constant use is invalid on 5.6
  - Fix fetch_hash() parse errors (CPAN RT#63524)
  - Fix handling of LITERAL values in response
  - Fix handling of field names with a dash (e.g. X-SAVEDATE)
  - fetch_hash now uses Escaped_results() method
  - Fixed Escaped_results() to properly join LITERAL data with the data that
    comes before and after it
  - append_file() does not interpret $date as expected (CPAN RT#60945)
  - $date should now be 1 (to use the file mtime) or a valid RFC3501 date
  - Address memory consumption with message_string()/append() (CPAN RT#61292)
  - Major problem with one function in IMAPClient (CPAN RT#61806)
  - Significant memory usage improvements
  - Relax get_envelope(), allow empty reply-to (CPAN RT#63444)
  - append_string could invalidate a good $date (CPAN RT#61068)
  - Fix logout error if delay between BYE and tagged OK (CPAN RT#60045)
  - Fix migrate() errors (CPAN RT#61062)
  - Rewrite migrate() to be functional and simple
  - Update README and clean up several old or out of date files
- Upstream dropped COPYRIGHT file, so drop it from %%doc
- Install into perl directories rather than vendor directories
- Take Makefile.PL input from /dev/null rather than answer interactive questions
- Add patch to drop Perl version requirement to 5.8.0

* Sat Oct  2 2010 Paul Howarth <paul@city-fan.org> - 3.25-1
- Update to 3.25
  - See Changes for full details
  - CPAN RT#57661: uninitialized value warning in IMAPClient::thread
  - CPAN RT#57337: Correctly handle multiparts in BodyStructure.pm
  - CPAN RT#57659: install fails when using cPanel GUI

* Sat Oct  2 2010 Paul Howarth <paul@city-fan.org> - 3.24-1
- Update to 3.24
  - See Changes for full details
  - CPAN RT#48912: wrong part numbers in multipart messages
  - CPAN RT#55527: [no] disconnect during DESTROY
  - CPAN RT#55898: append_file can send too many bytes
  - CPAN RT#57048: _quote_search() using $_ in loop instead of $v
- Turn off exec bits in examples to avoid docfile dependencies

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 3.23-3
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> - 3.23-2
- Fix dist tag to work with RHEL6 Beta

* Tue Feb  9 2010 Paul Howarth <paul@city-fan.org> - 3.23-1
- Import from Fedora
- Update to 3.23

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 3.21-2
- Rebuild against perl 5.10.1

* Fri Sep 25 2009 Stepan Kasal <skasal@redhat.com> - 3.21-1
- New upstream source

* Sat Sep  5 2009 Stepan Kasal <skasal@redhat.com> - 3.20-1
- New upstream source

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.14-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Mar 13 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 3.14-1
- Update to 3.14

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.08-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jul 21 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 3.08-1
- 3.08

* Tue Mar 11 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 3.05-1
- 3.05

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-6
- Rebuild for perl 5.10 (again)

* Mon Jan 28 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-5
- Rebuild for new perl

* Sun Aug 26 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-4
- License tag fix

* Mon Apr  9 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-3
- Set examples as non-exec, fix intepreter

* Wed Apr  4 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-2
- Add docs/ and examples/ as %%doc

* Mon Apr  2 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 2.2.9-1
- Initial package for Fedora
